Module 5 · 5.2
Français
Exporter l'agenda et les contacts depuis Google et Microsoft
Module 5: Agenda et contacts · Temps de lecture : 12 minutes
Objectif pédagogique : après cette leçon, vous saurez réaliser un export complet et exploitable des agendas et des contacts depuis Google et Microsoft, lire un fichier ICS et vCard, et vous saurez ce qui ne suit pas ou est transmis différemment lors d'un export.
Notions clés : iCalendar (ICS), VCALENDAR, VEVENT, UID, DTSTART, RRULE, EXDATE, VTIMEZONE et TZID, ORGANIZER et ATTENDEE, VALARM, vCard (VCF) 3.0 et 4.0, csv, Google Takeout, outil de migration
Deux formats de fichiers que presque tout le monde connaît
Vous déménagez agendas et contacts avec deux formats ouverts :
- iCalendar, des fichiers avec l'extension
.ics(RFC 5545), pour les agendas et les tâches. - vCard, des fichiers avec l'extension
.vcf, pour les contacts. Vous rencontrerez deux versions : 3.0 (RFC 2426) et 4.0 (RFC 6350).
Ce sont de simples fichiers texte. Vous pouvez les ouvrir dans un éditeur de texte, et c'est exactement ce que vous allez faire dans cette leçon. Qui sait ce qu'il y a dedans voit aussi ce qui manque.
Il existe souvent un chemin plus simple que l'export : de nombreux nouveaux services disposent d'un outil de migration qui, avec votre autorisation, récupère directement vos agendas et contacts chez Google ou Microsoft. C'est plus rapide et avec moins d'erreurs. Un export fait par vous-même reste néanmoins judicieux : comme contrôle (combien de rendez-vous et de contacts avais-je ?), comme sauvegarde avant de résilier l'ancien service, et comme solution de secours si l'outil de migration n'est pas autorisé par votre administrateur.
À quoi ressemble un fichier d'agenda
Un export de l'agenda de Bakkerij De Korrel commence ainsi :
BEGIN:VCALENDAR
VERSION:2.0
PRODID:-//Google Inc//Google Calendar 70.9054//EN
BEGIN:VTIMEZONE
TZID:Europe/Amsterdam
...
END:VTIMEZONE
BEGIN:VEVENT
UID:3f1a9c2e7b@google.com
DTSTART;TZID=Europe/Amsterdam:20261110T060000
DTEND;TZID=Europe/Amsterdam:20261110T070000
RRULE:FREQ=WEEKLY;BYDAY=TU
EXDATE;TZID=Europe/Amsterdam:20261229T060000
SUMMARY:Levering meel
ORGANIZER:mailto:anne@example.com
ATTENDEE;CN=Groothandel:mailto:verkoop@example.net
BEGIN:VALARM
TRIGGER:-PT30M
ACTION:DISPLAY
END:VALARM
END:VEVENT
END:VCALENDARCe que vous voyez :
| Ligne | Signification | Où cela peut mal se passer |
|---|---|---|
BEGIN:VCALENDAR et VERSION:2.0 | ceci est un fichier iCalendar | si cela manque, l'import est refusé |
BEGIN:VEVENT ... END:VEVENT | un rendez-vous | un END manquant rend le reste illisible |
UID | l'identifiant fixe du rendez-vous | sans UID, le serveur ne peut pas reconnaître les doublons |
DTSTART;TZID=... | heure de début dans un fuseau horaire | voir les fuseaux horaires ci-dessous |
RRULE | règle de répétition : tous les mardis | une règle invalide donne un seul rendez-vous au lieu d'une série |
EXDATE | exception : pas ce mardi-ci | |
ORGANIZER, ATTENDEE | qui a invité et qui est invité | voir les invitations ci-dessous |
VALARM | rappel, 30 minutes avant | tous les services ne reprennent pas les rappels |
Fuseaux horaires
Une heure avec TZID=Europe/Amsterdam signifie : 6 heures du matin à Amsterdam, même après le passage à l'heure d'été. Le fichier doit donc aussi contenir un bloc VTIMEZONE qui décrit ce fuseau horaire. Les exports issus d'Outlook utilisent souvent des noms Windows comme W. Europe Standard Time. Cela fonctionne bien tant que le bloc VTIMEZONE est présent. S'il manque, le nouveau service devine, et vous voyez les rendez-vous décalés d'une heure. Une heure qui se termine par Z (20261110T050000Z) est en UTC et toujours univoque. Une heure sans fuseau horaire et sans Z est appelée heure « flottante » : elle vaut dans le fuseau horaire de celui qui la consulte.
Les rendez-vous d'une journée entière apparaissent comme une date sans heure : DTSTART;VALUE=DATE:20261224.
Invitations
Un rendez-vous que vous avez organisé figure dans le fichier avec vous comme ORGANIZER. Après l'import, il apparaît dans votre nouvel agenda, mais les participants l'ont encore dans leur propre agenda comme une invitation venant de votre ancienne adresse, avec un UID de l'ancien service. Si vous modifiez le rendez-vous plus tard, ils recevront une nouvelle invitation. Pour les réunions récurrentes avec des personnes externes, il peut être plus propre de les réinviter après le passage. Les rendez-vous pour lesquels vous avez été invité arrivent comme un rendez-vous ordinaire ; les réponses à l'organisateur passent par e-mail.
Exporter depuis Google
- Agenda : dans Google Agenda, dans Paramètres, la section Importer et exporter, le bouton Exporter. Vous obtenez un fichier zip contenant un fichier ics par agenda dont vous êtes propriétaire. Les agendas que d'autres partagent avec vous n'y figurent pas ; c'est le propriétaire qui les exporte, ou vous les exportez par agenda depuis les paramètres de cet agenda si c'est autorisé.
- Contacts : dans Google Contacts, vous sélectionnez les contacts (ou tous), choisissez Exporter puis le format vCard. Google propose aussi « Google CSV » et « Outlook CSV » ; prenez vCard, cela conserve la structure (plusieurs numéros de téléphone, adresses, photo).
- Tout en une fois : Google Takeout (takeout.google.com) fournit l'agenda en ics, les contacts en vcf (ou csv) et Gmail en mbox, dans des fichiers zip. Pratique comme sauvegarde de l'ensemble du compte.
Les noms des menus changent de temps en temps ; en cas de doute, cherchez dans l'aide de Google « exporter l'agenda ».
Exporter depuis Microsoft
- Agenda : dans Outlook classique pour Windows, vous pouvez enregistrer un agenda comme fichier iCalendar (Enregistrer sous, avec choix de la période et « détails complets »). Choisissez une période qui remonte et s'étend suffisamment loin, et choisissez les détails complets, sinon vous n'exportez que les disponibilités libre/occupé. Dans Outlook sur le web, vous pouvez publier un agenda comme lien ICS et télécharger le fichier via ce lien ; désactivez ensuite la publication.
- Contacts : Outlook sur le web exporte les contacts en csv, pas en vCard. Outlook classique exporte aussi en masse vers csv ; vCard n'est possible là que par contact. De nombreux services CardDAV ne peuvent pas importer directement un fichier csv. Deux solutions : utiliser l'outil de migration de votre nouveau service (qui récupère les contacts directement), ou importer le csv dans un carnet d'adresses de Thunderbird et l'exporter ensuite en vCard.
- Agendas partagés et agendas de salles sont des agendas de l'organisation. C'est l'administrateur qui les exporte, ou vous les recréez dans le nouveau service.
Ce qui ne suit pas ou est transmis différemment lors d'un export
| Élément | Ce qui se passe |
|---|---|
| Pièces jointes aux rendez-vous | ne suivent généralement pas ; seulement un lien, ou rien |
| Couleurs et catégories | parfois comme CATEGORIES, souvent pas |
| Rappels | parfois, selon le service |
| Liens de visioconférence (Teams, Meet) | restent sous forme de texte dans le rendez-vous, mais ne fonctionnent plus après la résiliation |
| Groupes de contacts ou étiquettes | pas toujours ; vérifiez après l'import |
| Photos de contact | suivent dans vCard, mais alourdissent le fichier |
Compter avant de continuer
Notez avant l'export combien de contacts vous avez et, pour quelques agendas, combien de rendez-vous figurent dans une période fixe (par exemple novembre). Après l'import, vous recomptez. C'est le moyen le plus rapide de voir qu'il manque quelque chose. Dans l'exercice de cette leçon, vous laissez le programme compter et vérifier vos fichiers.
En pratique : à quoi cela ressemble chez un prestataire
Dans un Nextcloud WebOké, il existe deux outils de migration qui récupèrent directement : l'outil d'import WebOké pour Google (Drive, Photos, Agenda et Contacts) et Migration de données pour OneDrive et Microsoft 365, avec lequel vous importez aussi les contacts et agendas de votre compte Microsoft. Si votre agenda vient d'ailleurs, vous importez vous-même les fichiers ics et vCard (leçon 5.3). Nextcloud lit vCard 3.0 et 4.0. Chez d'autres services européens, des outils d'import comparables existent, ou un bouton d'import dans l'agenda et le carnet d'adresses ; les formats de fichiers sont partout les mêmes.
Résumé
- Vous déménagez les agendas en ics (iCalendar), les contacts en vcf (vCard 3.0 ou 4.0) ; ce sont des fichiers texte lisibles.
- Un outil de migration qui récupère directement est souvent plus simple, mais réalisez tout de même votre propre export comme contrôle et sauvegarde.
- Dans un fichier ics, portez attention à l'UID, à la RRULE, et aux fuseaux horaires avec un bloc VTIMEZONE ; sans cela, les rendez-vous se décalent.
- Outlook sur le web n'exporte les contacts qu'en csv ; utilisez un outil de migration ou convertissez le csv en vCard.
- Comptez au préalable contacts et rendez-vous, afin de voir après l'import si quelque chose manque.
Quiz
Exercice
Exercice A5.2 : Vérifier votre export de test. Exportez un agenda (ics) et vos contacts (vcf). Indiquez d'abord combien de contacts vous avez et combien de rendez-vous vous attendez. Téléversez ensuite les fichiers. Le programme vérifie leur validité, compte les rendez-vous, les répétitions et les contacts, recherche les fuseaux horaires sans description et les contacts en double, et compare avec vos chiffres. Les fichiers sont seulement lus et non conservés.
Exercice E5.2 : Qu'est-ce qui ne sera pas repris ? Ouvrez votre fichier ics dans un éditeur de texte. Recherchez un rendez-vous récurrent, un rendez-vous avec des participants et un rendez-vous avec un lien de visioconférence. Notez pour chaque rendez-vous ce que vous devez faire après le passage.
Exercice E5.2: Qu'est-ce qui ne sera pas repris ?
Ouvrez votre propre fichier ics dans un éditeur de texte.
Vos cases cochées et vos notes restent uniquement dans ce navigateur ; nous ne les envoyons nulle part. Si vous êtes connecté, nous enregistrons dans Mes formations uniquement le fait que vous avez terminé l'exercice.
Pour aller plus loin
Les étapes de ces articles valent pour les services de WebOké ; chez d'autres prestataires, cela fonctionne de manière comparable.
- Guide Nextcloud 13.5: Transférer son agenda et ses contacts depuis Google, iCloud ou Outlook (ics et vCard)
- Guide Nextcloud 13.2: Transférer Google Drive, Photos, Agenda et Contacts avec l'outil d'import WebOké
- Guide Nextcloud 13.4: Transférer OneDrive avec Migration des données
- Guide Nextcloud 13.6: De Microsoft 365 à WebOké : fichiers, documents, e-mail et agenda
- RFC 5545 (iCalendar), RFC 2426 (vCard 3.0), RFC 6350 (vCard 4.0)
- Aide Google Agenda : Exporter des événements ; Aide Google Contacts : Exporter des contacts ; Support Microsoft : Exporter des contacts depuis Outlook
